diff --git a/src/backend/utils/sort/tuplesort.c b/src/backend/utils/sort/tuplesort.c
index c2bd38f39f..91c0189577 100644
--- a/src/backend/utils/sort/tuplesort.c
+++ b/src/backend/utils/sort/tuplesort.c
@@ -1419,6 +1419,10 @@ tuplesort_reset(Tuplesortstate *state)
 	state->slabFreeHead = NULL;
 	state->growmemtuples = true;
 
+	state->tuplecontext = AllocSetContextCreate(state->sortcontext,
+										 "Caller tuples",
+										 ALLOCSET_DEFAULT_SIZES);
+
 	if (state->memtupsize < INITIAL_MEMTUPSIZE)
 	{
 		if (state->memtuples)
